#!/usr/bin/perl
my $inputblast = $ARGV[0];
my $outputjoin = $ARGV[1];
my $outputbest = $ARGV[2];
open(IB, $inputblast) or die ("Can't open $inputblast \n");
open (OJ, ">$outputjoin") or die ("Can't open $outputjoin \n");
open (OB, ">$outputbest") or die ("Can't open $outputbest \n");

my %all_match;
my @all_match_joined;


my $MAX_OVERLAP_FRACTION = 0.5;
my $MAX_OVERLAP_LENGTH_IGNORED = 3;


while (my $ligne = <IB>){
	my @fields = split (/\t/,$ligne);
	my %match;
	$match{"Query"}=$fields[0];
	$match{"Subject_id"}=$fields[1];
	$match{"Subject_start"}=$fields[8];
	$match{"Subject_end"}=$fields[9];
	$match{"Similarity"}=$fields[13];
	$match{"Query_length"}=$fields[14];
	$match{"Subject_length"}=$fields[15];
	$match{"Subject"}=$fields[16];
	
	if ($fields[6]<=$fields[7]){
		$match{"Query_start"}=$fields[6];
		$match{"Query_end"}=$fields[7];
		$match{"Orientation"}="+";
		#print "+ $ligne";
	}
	else {
		$match{"Query_start"}=$fields[7];
		$match{"Query_end"}=$fields[6];
		$match{"Orientation"}="-";
		#print "- $ligne";
	}
	
	if ($fields[9]<=$fields[8]){
		$match{"Subject_start"}=$fields[9];
		$match{"Subject_end"}=$fields[8];
		$match{"Orientation"}="+";
		#print "+ $ligne";
	}
	else {
		$match{"Subject_start"}=$fields[8];
		$match{"Subject_end"}=$fields[9];
		$match{"Orientation"}="-";
		#print "- $ligne";
	}
	
	$match{"Ligne"}=$ligne;
	my $key = $match{"Query"}."##".$match{"Subject"}."##".$match{"Orientation"};
	if ($match{"Subject_length"}==0){
		print $ligne,"\n",$match{"Subject_length"},"\n";
	}	
	my @match_table;

	if ($all_match{$key}){
		@match_table = @{$all_match{$key}};
	}
	push (@match_table,\%match);
	$all_match{$key} = \@match_table;
}

foreach my $key (keys %all_match){
	my @match_table = @{$all_match{$key}};
	#### Sort
	@match_table = sort mysort @match_table;
	
	
	my @duplicate;
	my @overlap;
	for (my $i=0;$i<=$#match_table;$i++){
		push (@duplicate,0);
	}
	print "\nTable Match ($#match_table)\n";
	for (my $i=0;$i<=$#match_table;$i++){
		my %match=%{$match_table[$i]};
		print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t";
		print $match{"Subject_start"},"\t",$match{"Subject_end"},"\t",$match{"Subject_length"},"\t",$match{"Similarity"},"\n";
	}
	
	#Scan d'inclusion strict
	for (my $i=0;$i<=$#match_table;$i++){
		my %match1=%{$match_table[$i]};
		for (my $j=0;$j<=$#match_table;$j++){
			if (($j != $i)&&($duplicate[$j]==0)){ # On scan dans les deux sens, pas seuelment $j = $i+1 a cause du last;
				my %match2=%{$match_table[$j]};
				# Inclus Subject
				if (($match1{"Subject_start"}>=$match2{"Subject_start"})&&($match1{"Subject_end"}<=$match2{"Subject_end"}))
				{
					$duplicate[$i]=1;
					# print $i," : 1 : ",$match1{"Query"},"\t",$match1{"Subject_id"},"\t",$match1{"Query_start"},"\t",$match1{"Query_end"},"\t",$match1{"Subject_start"},"\t",$match1{"Subject_end"},"\n";
					# print $j," : 1 : ",$match2{"Query"},"\t",$match2{"Subject_id"},"\t",$match2{"Query_start"},"\t",$match2{"Query_end"},"\t",$match2{"Subject_start"},"\t",$match2{"Subject_end"},"\n";
	
					last;
				}
				# Inclus Query
				elsif (($match1{"Query_start"}>=$match2{"Query_start"})&&($match1{"Query_end"}<=$match2{"Query_end"}))
				{
					$duplicate[$i]=2;
					# print $i," : 2 : ",$match1{"Query"},"\t",$match1{"Subject_id"},"\t",$match1{"Query_start"},"\t",$match1{"Query_end"},"\t",$match1{"Subject_start"},"\t",$match1{"Subject_end"},"\n";
					# print $j," : 2 : ",$match2{"Query"},"\t",$match2{"Subject_id"},"\t",$match2{"Query_start"},"\t",$match2{"Query_end"},"\t",$match2{"Subject_start"},"\t",$match2{"Subject_end"},"\n";
					last;
				}

			}
		}
	}
	
	my @match_table_filtered;
	for (my $i=0;$i<=$#match_table;$i++){
		if ($duplicate[$i] == 0){
			push (@match_table_filtered,$match_table[$i]);
		}
	}
	
	if ($#match_table > $#match_table_filtered){
		@match_table = @match_table_filtered;
		print "Table Match filtered 1 ($#match_table)\n";
		for (my $i=0;$i<=$#match_table;$i++){
			my %match=%{$match_table[$i]};
			print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t";
			print $match{"Subject_start"},"\t",$match{"Subject_end"},"\t",$match{"Subject_length"},"\t",$match{"Similarity"},"\n";
			#print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t",$match{"Subject_start"},"\t",$match{"Subject_end"},"\n";
		}
	}
	
	undef @duplicate;
	for (my $i=0;$i<=$#match_table;$i++){
		push (@duplicate,0);
	}
	########
	
	###Scan d'overlap trop important
	# D'abord subject
	for (my $i=0;$i<=$#match_table;$i++){
		my %match1=%{$match_table[$i]};
		for (my $j=$i+1;$j<=$#match_table;$j++){
			my %match2=%{$match_table[$j]};
			if (($match1{"Subject_start"}<=$match2{"Subject_start"})&&($match1{"Subject_end"}>=$match2{"Subject_start"})&&($match1{"Subject_end"}<=$match2{"Subject_end"}))
			 {
				my $overlap_length = $match1{"Subject_end"} - $match2{"Subject_start"}+1;
				my $length1 = $match1{"Subject_end"} - $match1{"Subject_start"} +1;
				my $length2 = $match2{"Subject_end"} - $match2{"Subject_start"} +1;
				
				if (($length1 >= $length2)&&($overlap_length > $length2 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$j]=1;
					# print "DUPLICATE : $j\n";
				}
				elsif (($length2 >= $length1)&&($overlap_length > $length1 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$i]=1;
					# print "DUPLICATE : $i\n";
				}
				else {
				}
				
				# print "$i : 3 : $overlap_length : $length1\n";
				# print "$j : 3 : $overlap_length : $length2\n";
			}
			elsif (($match2{"Subject_start"}<=$match1{"Subject_start"})&&($match2{"Subject_end"}>=$match1{"Subject_start"})&&($match2{"Subject_end"}<=$match1{"Subject_end"}))
			{
				my $overlap_length = $match2{"Subject_end"} - $match1{"Subject_start"}+1;
				my $length1 = $match1{"Subject_end"} - $match1{"Subject_start"} +1;
				my $length2 = $match2{"Subject_end"} - $match2{"Subject_start"} +1;
				
				if (($length1 >= $length2)&&($overlap_length > $length2 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$j]=1;
					# print "DUPLICATE : $j\n";
					# print "($length1 >= $length2)&&($overlap_length > $length2 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)\n";
				}
				elsif (($length2 >= $length1)&&($overlap_length > $length1 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$i]=1;
					# print "DUPLICATE : $i\n";
					# print "($length2 >= $length1)&&($overlap_length > $length1 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)\n";
				}
				else {
				}
				
				# print "((",$match2{"Subject_start"},"<=",$match1{"Subject_start"},")&&(",$match2{"Subject_end"},">=",$match1{"Subject_start"},")&&(",$match2{"Subject_end"},"<=",$match1{"Subject_end"},"))\n";
				# print "$i : 4 : $overlap_length : $length1\n";
				# print "$j : 4 : $overlap_length : $length2\n";
			}
		}
	}
		
	undef @match_table_filtered;
	for (my $i=0;$i<=$#match_table;$i++){
		if ($duplicate[$i] == 0){
			push (@match_table_filtered,$match_table[$i]);
		}
	}
	
	if ($#match_table > $#match_table_filtered){
		@match_table = @match_table_filtered;
		print "Table Match filtered 2 ($#match_table)\n";
		for (my $i=0;$i<=$#match_table;$i++){
			my %match=%{$match_table[$i]};
			print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t";
			print $match{"Subject_start"},"\t",$match{"Subject_end"},"\t",$match{"Subject_length"},"\t",$match{"Similarity"},"\n";
			#print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t",$match{"Subject_start"},"\t",$match{"Subject_end"},"\n";
		}
	}
	
	undef @duplicate;
	for (my $i=0;$i<=$#match_table;$i++){
		push (@duplicate,0);
	}
	
	# Ensuite Query (Subject puis Query pour evitez des deletions complementaires query update qui enleverait toutes les entrées)
			
	for (my $i=0;$i<=$#match_table;$i++){
		my %match1=%{$match_table[$i]};
		for (my $j=$i+1;$j<=$#match_table;$j++){
			my %match2=%{$match_table[$j]};			
			if (($match1{"Query_start"}<=$match2{"Query_start"})&&($match1{"Query_end"}>=$match2{"Query_start"})&&($match1{"Query_end"}<=$match2{"Query_end"}))
			{
				my $overlap_length = $match1{"Query_end"} - $match2{"Query_start"}+1;
				my $length1 = $match1{"Query_end"} - $match1{"Query_start"} +1;
				my $length2 = $match2{"Query_end"} - $match2{"Query_start"} +1;
				
				if (($length1 >= $length2)&&($overlap_length > $length2 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$j]=1;
					# print "DUPLICATE : $j\n";
				}
				elsif (($length2 >= $length1)&&($overlap_length > $length1 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$i]=1;
					# print "DUPLICATE : $i\n";
				}
				else {
				}
				
				# print "$i : 5 : $overlap_length : $length1\n";
				# print "$j : 5 : $overlap_length : $length2\n";
			}
			elsif (($match2{"Query_start"}<=$match1{"Query_start"})&&($match2{"Query_end"}>=$match1{"Query_start"})&&($match2{"Query_end"}<=$match1{"Query_end"}))
			{
				my $overlap_length = $match2{"Query_end"} - $match1{"Query_start"}+1;
				my $length1 = $match1{"Query_end"} - $match1{"Query_start"} +1;
				my $length2 = $match2{"Query_end"} - $match2{"Query_start"} +1;
				
				if (($length1 >= $length2)&&($overlap_length > $length2 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$j]=1;
					# print "DUPLICATE : $j\n";
				}
				elsif (($length2 >= $length1)&&($overlap_length > $length1 * $MAX_OVERLAP_FRACTION)&&($overlap_length > $MAX_OVERLAP_LENGTH_IGNORED)){
					$duplicate[$i]=1;
					# print "DUPLICATE : $i\n";
				}
				else {
				}
				
				# print "$i : 6 : $overlap_length : $length1\n";
				# print "$j : 6 : $overlap_length : $length2\n";
			}
		}
	}
			
	undef @match_table_filtered;
	for (my $i=0;$i<=$#match_table;$i++){
		if ($duplicate[$i] == 0){
			push (@match_table_filtered,$match_table[$i]);
		}
	}
	
	if ($#match_table > $#match_table_filtered){
		@match_table = @match_table_filtered;
		print "Table Match filtered 3 ($#match_table)\n";
		for (my $i=0;$i<=$#match_table;$i++){
			my %match=%{$match_table[$i]};
			print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t";
			print $match{"Subject_start"},"\t",$match{"Subject_end"},"\t",$match{"Subject_length"},"\t",$match{"Similarity"},"\n";
			# print $match{"Query"},"\t",$match{"Subject_id"},"\t",$match{"Orientation"},"\t",$match{"Query_start"},"\t",$match{"Query_end"},"\t",$match{"Subject_start"},"\t",$match{"Subject_end"},"\n";
		}
	}	
	
	
	#Calcul des nouvelles metriques
	
	my $overlap_length = 0;
	my $min_query = 0;
	my $max_query = 0;
	my $min_subject = 0;
	my $max_subject = 0;
	my $Subject_coverage;
	my $Identity;
	my $nb_match = 0;
	

	my $nb_covered_subject=0;
	my $nb_covered_query=0;
	my %match=%{$match_table[0]};
	my $q_length = $match{"Query_length"};
	my $sub_length = $match{"Subject_length"};
	my $subject = $match{"Subject"};
	my $min_query = $match{"Query_start"};
	my $max_query = $match{"Query_end"};
	my $min_subject = $match{"Subject_start"};
	my $max_subject = $match{"Subject_end"};
	my $orientation = $match{"Orientation"};
	my $Query = $match{"Query"};
	my $Subject_Id = $match{"Subject_id"};
	my $Subject = $match{"Subject"};
	
	
	for (my $i=0;$i<=$#match_table;$i++){
		my %match1=%{$match_table[$i]};
		$nb_covered_subject += $match1{"Subject_end"} - $match1{"Subject_start"} +1;
		$nb_covered_query += $match1{"Query_end"} - $match1{"Query_start"} +1;
			
		if ($match1{"Query_start"}<$min_query){
			$min_query = $match1{"Query_start"};
		}
		if ($match1{"Query_end"}>$max_query){
			$max_query = $match1{"Query_end"};
		}
		if ($match1{"Subject_start"}<$min_subject){
			$min_subject = $match1{"Subject_start"};
		}
		if ($match1{"Subject_end"}>$max_subject){
			$max_subject = $match1{"Subject_end"};
		}
		
		$nb_match += $match1{"Similarity"};
		# print "TEST : ",$match1{"Similarity"},"\t",$nb_match,"\n";
		
		for (my $j=$i+1;$j<=$#match_table;$j++){
			my $overlap_query=0;
			my $overlap_subject=0;
			my %match2=%{$match_table[$j]};

			if (($match1{"Subject_start"}<=$match2{"Subject_start"})&&($match1{"Subject_end"}>=$match2{"Subject_start"})&&($match1{"Subject_end"}<=$match2{"Subject_end"}))
			{
				$overlap_subject = $match1{"Subject_end"} - $match2{"Subject_start"}+1;
				# print "$i : $j : 3 : $overlap_subject\n";
			}
			elsif (($match2{"Subject_start"}<=$match1{"Subject_start"})&&($match2{"Subject_end"}>=$match1{"Subject_start"})&&($match2{"Subject_end"}<=$match1{"Subject_end"}))
			{
				$overlap_subject = $match2{"Subject_end"} - $match1{"Subject_start"}+1;
				# print "$i : $j : 4 : $overlap_subject\n";
			}
			
			if (($match1{"Query_start"}<=$match2{"Query_start"})&&($match1{"Query_end"}>=$match2{"Query_start"})&&($match1{"Query_end"}<=$match2{"Query_end"}))
			{
				$overlap_query = $match1{"Query_end"} - $match2{"Query_start"} +1;
				# print "$i : $j : 5 : $overlap_query\n";
			}
			elsif (($match2{"Query_start"}<=$match1{"Query_start"})&&($match2{"Query_end"}>=$match1{"Query_start"})&&($match2{"Query_end"}<=$match1{"Query_end"}))
			{
				$overlap_query = $match2{"Query_end"} - $match1{"Query_start"}+1;
				# print "$i : $j : 6 : $overlap_query\n";
			}
			
			if ($overlap_query > $overlap_subject){
				$overlap_length += $overlap_query;
			}
			else {
				$overlap_length += $overlap_subject;
			}
			
			$nb_covered_subject -= $overlap_subject;
			$nb_covered_query-= $overlap_query;
			
		}
		
	}
	### Cas des tblastx ou le nb match est en aa, et les nb_covered en base
	if ($nb_match/$nb_covered_subject<0.34){
		$nb_match = $nb_match *3;
	}
	####
	
	$Identity = sprintf("%.2f",($nb_match-$overlap_length)*100/$nb_covered_subject);

	$Subject_coverage = sprintf("%.2f",$nb_covered_subject*100/$sub_length);
	$Query_coverage = sprintf("%.2f",$nb_covered_query*100/$q_length);
	
	print "Final\n";
	print $Query,"\t",$Subject_Id,"\t",$orientation,"\t",$min_query,"\t",$max_query,"\t",$min_subject,"\t",$max_subject,"\t",$sub_length,"\t";
	print "NB:",$nb_match,"\t","O:",$overlap_length,"\t","CQ:",$nb_covered_query,"\t","CS:",$nb_covered_subject,"\t",$Query_coverage,"\t",$Subject_coverage,"\t",$Identity,"\n";

	if ($subject=~/^(.*?)\s*$/){
		$subject = $1;
	}
	
	my %match_joined;
	$match_joined{"Query"}=$Query;
	$match_joined{"Query_start"}=$min_query;
	$match_joined{"Query_end"}=$max_query;
	$match_joined{"Query_length"}=$q_length;
	$match_joined{"QCoverage"} = $Query_coverage;
	$match_joined{"Subject_id"}=$Subject_Id;
	$match_joined{"Subject"}=$subject;
	$match_joined{"Subject_start"}=$min_subject;
	$match_joined{"Subject_end"}=$max_subject;
	$match_joined{"Subject_length"}=$sub_length;
	$match_joined{"SCoverage"} = $Subject_coverage;
	$match_joined{"Similarity"}=$Identity;
	$match_joined{"Nbmatch"}=$nb_match-$overlap_length;
	$match_joined{"Display"}="$Query\t$Subject_Id\t$orientation\t$Query_coverage%\t$Subject_coverage%\t$Identity%\t$min_query\t$max_query\t$min_subject\t$max_subject\t$q_length\t$sub_length\t$subject";
	
	my $chr;
	my $start;
	my $end;
	
	if ($match_joined{"Query"}=~/(.*?)\:(\d+)[\.]+(\d+)/){
		$chr =$1;
		$start = $2;
		$end = $3;
		
	}
	else {
		print "Error Parsing Query : ",$match_joined{"Query"},"\n";
		exit(0);
	}
	
	my $subid = $match_joined{"Subject_id"};
	my $nb = $nb_match-$overlap_length;
	
	my $key = "$chr#$start#$end#$nb#$subid";
	$all_match_joined{$key} = \%match_joined;
	
	
	# my %match_joined;
	# my $nb_covered=0;
	# my $length=0;
	# for (my $i=0;$i<=$#match_table;$i++){
		# my %match=%{$match_table[$i]};
		# $nb_covered+=$match{"Similarity"};
		# $length = $match{"Subject_length"}
	# }
	# # if ($match{"Subject_length"} == 0){
		# # print $key,"\n",$match{"Ligne"},"\n",$match{"Subject"},"\n";
		# # exit(0);
	# # }
	# my $similarity = sprintf("%.2f",$nb_covered / $length);
	
	# print "TEST : ",$key,"\t",$similarity,"\t",$nb_covered,"\t",$length,"\n";
	
	
	# if ($similarity > 1){
		# for (my $i=0;$i<=$#match_table;$i++){
			# my %match=%{$match_table[$i]};
			# print "----- : ",$match{"Ligne"},"\n";
			# exit(0);
		# }	
	# }
	# $match_joined{"Query"}=$match{"Query"};
	# $match_joined{"Subject"}=$match{"Subject"};
	# $match_joined{"Subject_id"}=$match{"Subject_id"};
	# $match_joined{"Similarity"}=$similarity;
	# $match_joined{"Query_length"}=$match{"Query_length"};
	# $match_joined{"Subject_length"}=$match{"Subject_length"};
	# push(@all_match_joined,\%match_joined);

}

close (IB);

my %all_match_joined_best;
foreach my $key (sort sortkey keys %all_match_joined){
	my %match = %{$all_match_joined{$key}};
	print OJ $match{"Display"},"\n";
	my $shortkey = $match{"Query"};
	if ($all_match_joined_best{$shortkey}){
	}
	else {
		$all_match_joined_best{$shortkey} = \%match;
		print OB $match{"Display"},"\n";
	}
	
}

# for (my $i=0;$i<=$#all_match_joined;$i++){
	# my $match_joined = %{$all_match_joined[$i]};
	# print $match_joined{"Query"},"\t",$match_joined{"Subject"},"\t",$match_joined{"Subject_id"},"\t",$match_joined{"Similarity"},"\t",$match_joined{"Query_length"},"\t",$match_joined{"Subject_length"},"\n";
# }


sub mysort{
	my %matcha=%{$a};
	my %matchb=%{$b};
	
	#print "TEST : ",$matcha{"Query_start"}, " / ", $matchb{"Query_start"},"\n";
	
	$matcha{"Query_start"} <=> $matchb{"Query_start"}
	||
	$matcha{"Query_end"} <=> $matchb{"Query_end"}
	
}

sub sortkey {
	my @fieldsa = split (/\#/,$a);
	my @fieldsb = split (/\#/,$b);
	
	#print "$a\n$b\n";
	#print $fieldsa[0]," cmp ",$fieldsb[0],"\n";
	#exit(0);

	$fieldsa[0] cmp $fieldsb[0]
	||
	$fieldsa[1] <=> $fieldsb[1]
	||
	$fieldsb[2] <=> $fieldsa[2]
	||
	$fieldsb[3] <=> $fieldsa[3]
}
